#define begin {
#define end   }

#include <conio.h>
#include <ctype.h>
#include <dir.h>
#include <dos.h>
#include <io.h>
#include <process.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys\stat.h>
#include <time.h>

void build_data_file(void)
begin
int done;
struct ffblk entry;
char lvar[20], dvar[20];
int  dint, lint;
FILE * file;
textcolor(YELLOW);
cputs("AILAUNCH not found.\r\n\r\n");
cputs("I need some info to create it:\r\n");
textcolor(LIGHTCYAN);
// get launch percentage
do begin
   cputs(" What are the Odds of Launching (1-100): ");
   gets(lvar);
   lint = atoi(lvar);
   end
while(lint < 1 || lint > 100);
// get earliest launch hour
do begin
   cputs(" What is Earliest Hour to Launch (0-23): ");
   gets(dvar);
   dint = atoi(dvar);
   end
while(dint < 0 && lint > 23);
// make file
file = fopen("AILAUNCH.DAT","w+t");
if(file==NULL)
   begin
   cputs("Disk Error. Probably Hard Drive Full.\r\n");
   exit(1);
   end
fprintf(file, "%d %d\n", lint, dint);
done = findfirst("*.AI", &entry, 0);
while(!done)
   begin
   fprintf(file, "%-11s %d\n", entry.ff_name, 0);
   done = findnext(&entry);
   end
fclose(file);
textcolor(YELLOW);
cputs("\r\nLAUNCH.DAT created.\r\n");
end

void main(void)
begin
char SHIPNAME[100][40];
char day[100];
char work[100];
int  lint, dint;
struct date Date;
struct time Time;
FILE *file;
int sx = 0;
int dx, ch;
int launch = 1;
textbackground(BLUE);
textcolor(WHITE);
cputs("Ultimate Universe Artifical Player Launcher                                 ");
textattr(WHITE);
cputs("\r\n\r\n");
randomize();
file = fopen("AILAUNCH.DAT","r+t");
if(file==NULL)
   begin
   build_data_file();
   exit(0);
   end
fscanf(file, "%d %d\n", &lint, &dint);
while((fgets(work, 80, file))!=NULL)
   begin
   sscanf(work, "%s %d", &SHIPNAME[sx], &day[sx]);
   sx++;
   end
fclose(file);
getdate(&Date);
gettime(&Time);
if(Time.ti_hour < dint)
   begin
   cputs("It's too early, talk to me later.\r\n");
   exit(3);
   end
if(random(100) > lint)
   begin
   cputs("No Launch this run\r\n");
   exit(2);
   end
ch = random(sx);
if(day[ch]==Date.da_day) launch = 0;
day[ch] = Date.da_day;
file = fopen("AILAUNCH.DAT","w+t");
fprintf(file, "%d %d\n", lint, dint);
for(dx=0;dx<sx;dx++)
   begin
   textcolor(LIGHTCYAN);
   if(dx==ch)
      begin
      textcolor(YELLOW);
      cputs(">");
      end
     else
      cputs(" ");
   if(day[dx]==Date.da_day) textcolor(DARKGRAY);
   cprintf("%s\r\n", SHIPNAME[dx]);
   if((access(SHIPNAME[dx],0))==0)
      fprintf(file,"%-11s %d\n", SHIPNAME[dx], day[dx]);
   end
fclose(file);
if(launch) execl("AI.EXE","AI.EXE",SHIPNAME[ch]);
end

